<template>
    <div class="pl-4 pr-4 pt-4">
        <h1>All Posts</h1>
        <div>
            <BTable
                responsive
                sticky-header
                stacked="lg"
                show-empty
                :fields="fields"
                :items="items"
                :current-page="currentPage"
                :per-page="0"
                head-variant="light"
            >
                <template #cell(index)="data">
                    {{ (currentPage - 1) * perPage + data.index + 1 }}
                </template>
                <template #cell(author)="data">
                    {{ data.value.username }}
                </template>
                <template #cell(tagList)="data">
                    {{ data.value && data.value.join(',') }}
                </template>
                <template #cell(body)="data">
                    {{ getFirst20Words(data.value) }}
                </template>
                <template #cell(createdAt)="data">
                    {{ customDateFormat(data.value) }}
                </template>
                <template #cell(function)="data">
                    <BDropdown class="mx-1" right text="...      " variant="info">
                        <BDropdownItem :to="{ path: `/article/edit/${data.item.slug}` }"> Edit </BDropdownItem>
                        <BDropdownItem @click.prevent="showDeleteModal(data.item.slug)">Delete</BDropdownItem>
                    </BDropdown>
                </template>
            </BTable>
            <BPaginationNav
                use-router
                :link-gen="linkGen"
                v-model="currentPage"
                :number-of-pages="totalItems"
                :per-page="perPage"
                aria-controls="my-table"
                align="center"
                varient="dark"
            ></BPaginationNav>
        </div>
        <DeleteArticleModal :show="deleteModal.show" :slug="deleteModal.slug"></DeleteArticleModal>
    </div>
</template>

<script>
import DeleteArticleModal from '@/components/Article/DeleteArticleModal';
export default {
    name: 'ArticleList',
    components: { DeleteArticleModal },
    data() {
        return {
            perPage: 10,
            currentPage: 1,
            totalItems: 1,
            items: [],
            isBusy: true,
            deleteModal: {
                slug: '',
                show: false,
            },
            fields: [
                // A virtual column that doesn't exist in items
                { key: 'index', label: '#' },
                // A regular column
                'title',
                // A column that needs custom formatting
                { key: 'author', label: 'Author' },
                // A column that needs custom formatting
                { key: 'tagList', label: 'Tags' },
                // A column that needs custom formatting
                { key: 'body', label: 'Excerpt' },
                // A column that needs custom formatting
                { key: 'createdAt', label: 'Created' },
                { key: 'function', label: '' },
            ],
        };
    },
    methods: {
        getFirst20Words: (text) => {
            if (!text) {
                return '';
            }
            text = text.split(' ');
            if (text.length < 21) {
                return text.join(' ');
            }
            return text.slice(0, 20).join(' ');
        },
        customDateFormat: (date) => {
            date = new Date(date).toDateString();
            date = date.split(' ');
            date[date.length - 1] = ',' + date[date.length - 1];
            return date.splice(1).join(' ');
        },
        async fetchData(offset) {
            const response = await this.$root.axiosApiCall(
                'Article Failed',
                'get',
                'articles',
                {
                    offset,
                    limit: this.perPage,
                },
                {},
            );

            this.items = response && response.articles;
            this.totalItems = response && response.articlesCount;
        },
        linkGen(pageNum) {
            return pageNum === 1 ? '/article' : `/article/page/${pageNum}`;
        },
        showDeleteModal(slug) {
            this.deleteModal = {
                show: true,
                slug: slug,
            };
        },
    },
    created() {
        if (this.$route.params.id) {
            this.currentPage = this.$route.params.id;
        }
    },
    mounted() {
        this.fetchData().catch((error) => {
            console.error(error);
        });
    },
    watch: {
        currentPage: {
            handler: function (value) {
                const offset = (value - 1) * this.perPage;
                this.isBusy = true;
                this.fetchData(offset).catch((error) => {
                    console.error(error);
                });
            },
        },
    },
};
</script>

<style scoped></style>
